/***
 * CADSP
 *
 *		AppleTalk Data Stream Protocol handler
 *
 *		ask this object to handle connections over appletalk
 *
 *		Copyright  1992 Bernard Bernstein. All rights reserved.
 ***/ 

#pragma once

#include "CADSP.h"
#include "CNBP.h"

class CMessenger : private CADSP {
	
public:


			/* allocate and deallocate stuff */

	void	IMessenger(void);
	void	Dispose(void);


			/* accessing stuff */
	short		GetSocket(void);
	AddrBlock	GetRemoteAddr(void);
	CNBP 		*GetNBP(void);
	void		SetSocket(short aSocket);
	void		SetRemoteAddr(AddrBlock anAddr);
	

			/* NBP stuff */
			
	void	SetName(Str32 objName, Str32 typeName, Str32 zoneName);
	void	PostName(void);
	void	RemoveName(void);


			/* establishing and terminating connection */

	void	MakeConnector(void);
	void	KillConnector(void);
	void	OpenSession(AddrBlock addr);
	void	WaitForSession(void);
	Boolean	StillWaitingForSession(void);
	void	CloseSession(void);


			/* maintaining a connection */

	void	ReceiveMessage(void *message, short amountToRead, short *amountRead);
	void	SendMessage(void *message, short size);
	Boolean	MessageWaiting(void);
	

protected:


private:

	Boolean		named;
	Boolean		waitingForConnect;
	
	short		itsSocket;
	AddrBlock	itsRemoteAddr;
	CNBP		*itsNBP;

};

