/***
 * CNBP
 *
 *		Name Binding Protocol handler
 *
 *		ask this object to handle names over appletalk
 *
 *		Copyright  1992 Bernard Bernstein. All rights reserved.
 ***/ 

#pragma once

#include <CObject.h>
#include <Appletalk.h>

class CArray;

class CNBP : CObject {

public:
	void	INBP(void);
	void	Dispose(void);
	void	SetName(Str32 objName, Str32 typeName, Str32 zoneName);
	void	SetSocket(short socket);
	void	MatchNames(Str32 objMatch, Str32 typeMatch, Str32 zoneMatch, 
						CArray *matches);
	
	void	Register(void);
	void	Lookup(Str32 objMatch, Str32 typeMatch, Str32 zoneMatch,
					void *buffer, short size, short maxToGet);
	void	Remove(void);


	Boolean	SetSelfSend(Boolean selfsend);
protected:


private:
	MPPPBPtr		itsMppPb;
	Boolean			nameOnTable;
	
	Str32			itsObjName;
	Str32			itsTypeName;
	Str32			itsZoneName;
	Boolean			itsNamesSet;
	
	short			itsSocket;
	Boolean			itsSocketSet;
	
	NamesTableEntry	*nte;			// owned by NBP

};


typedef struct nbpname {
	Str32 name;
	Str32 type;
	Str32 zone;
	AddrBlock addr;
} NBPAddrNameRec;
